/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include <qfile.h>
#include <qmessagebox.h>	
#include <stdlib.h> // realloc()
#include <ctype.h> // tolower()
#include <string.h> // strtok()
//#include <unistd.h> // unlink()
#include "configToolBar.h"


CConfigToolBar::CConfigToolBar(QString name)
{
    total = 0;
    localName = name;
    readFile();
}


void CConfigToolBar::readFile()
{
	QFile file(localName.data());
	file.open( IO_ReadWrite );
	// the file is created if it doesn't exist

	QString tmp;
	actioninfo fi;
	fi.leftbutton[0] = fi.rightbutton[0] = 0;
	fi.leftIndex = fi.rightIndex = -1;

	nb = 0;

	// let's add all the lines of the file to the chained list
	while(file.atEnd() == FALSE)
	{
		file.readLine(buffer, 2048);
		buffer[strlen(buffer) - 1] = 0;

		if (buffer[0] != '#')
		{
			//debug("Premier cars de la chaine : %d %d", buffer[0], buffer[1]);
			if (buffer[0] != 0)
			{
			    tmp = buffer;
			    if (tmp.left(7) == "button=")
			    {
					if (fi.leftbutton[0] > 0 || fi.rightbutton[0] > 0)
					{
				    	nb++;
				    	total = (actioninfo *)realloc(total, nb * sizeof(actioninfo));
				    	strcpy((total + (nb - 1)) -> leftbutton, fi.leftbutton);
				    	strcpy((total + (nb - 1)) -> rightbutton, fi.rightbutton);
				    	(total + (nb - 1)) -> leftIndex = fi.leftIndex;
				    	(total + (nb - 1)) -> rightIndex = fi.rightIndex;

				    	fi.leftbutton[0] = fi.rightbutton[0] = 0;
				    	fi.leftIndex = fi.rightIndex = -1;
					}
			    }

			    else if(tmp.left(11) == "leftbutton=")
			    {
				if (fi.leftbutton[0] > 0)
				    strcat(fi.leftbutton, "\n");

				strcat(fi.leftbutton, tmp.right(tmp.length() - 11));
			    }				    

			    else if(tmp.left(12) == "rightbutton=")
			    {
				if (fi.rightbutton[0] > 0)
				    strcat(fi.rightbutton, "\n");

				strcat(fi.rightbutton, tmp.right(tmp.length() - 12));
			    }				    
	    
			    else if(tmp.left(11) == "leftpixmap=")
			    {
				fi.leftIndex = tmp.right(tmp.length() - 11).toInt();
			    }

			    else if(tmp.left(12) == "rightpixmap=")
			    {
				fi.rightIndex = tmp.right(tmp.length() - 12).toInt();
			    }

			     
			}
		}
	}	

	if (fi.leftbutton[0] > 0 || fi.rightbutton[0] > 0 || fi.leftIndex > -1 || fi.rightIndex > -1 )
	{
	    nb++;
	    total = (actioninfo *)realloc(total, nb * sizeof(actioninfo));
	    strcpy((total + (nb - 1)) -> leftbutton, fi.leftbutton);
	    strcpy((total + (nb - 1)) -> rightbutton, fi.rightbutton);
	    (total + (nb - 1)) -> leftIndex = fi.leftIndex;
	    (total + (nb - 1)) -> rightIndex = fi.rightIndex;

	    fi.leftbutton[0] = fi.rightbutton[0] = 0;
	    fi.leftIndex = fi.rightIndex = -1;
	}


	file.close();

}

int CConfigToolBar::addEntry(QString leftValue, int leftIndex, QString rightValue, int rightIndex)
{
    nb++;
    total = (actioninfo *)realloc(total, nb * sizeof(actioninfo));
    strcpy((total + (nb - 1)) -> leftbutton, leftValue.data());
    strcpy((total + (nb - 1)) -> rightbutton, rightValue.data());
    (total + (nb - 1)) -> leftIndex = leftIndex;
    (total + (nb - 1)) -> rightIndex = rightIndex;

    return nb - 1;
}

bool CConfigToolBar::removeEntry(int index)
{
    return TRUE;
    //return total.remove(index);
}	   

actioninfo *CConfigToolBar::get(unsigned int index)
{
    if (index < nb)
	return (total + index);
    else
	return 0;
}

void CConfigToolBar::set(const unsigned int index, actioninfo *fi)
{
    actioninfo *f = get(index);
    strcpy(f -> leftbutton, fi -> leftbutton);
    strcpy(f -> rightbutton, fi -> rightbutton);

    f -> rightIndex = fi -> rightIndex;
    f -> leftIndex = fi -> leftIndex;
}

void CConfigToolBar::save()
{
  	//debug("save du fichier");
	if (QFile::remove(localName.data()) == FALSE)
	{
		debug("Warning : could not delete the file %s, aborting", localName.data());
		return;
	}

	QString tmp;
	actioninfo *fi;

	QFile file(localName.data());	
	file.open(IO_WriteOnly);

	QString action = "";

	for(int i = 0 ; i < nb ; i++)
	{
	    fi = total + i;
	    tmp.sprintf("button=%d", i);
	    file.writeBlock(tmp.data(), tmp.length());
	    file.writeBlock("\n", 1);

	    if (strlen(fi -> leftbutton)) // there is an action associated to the left button
		for (unsigned int i = 0 ; i <= strlen(fi -> leftbutton) ; i++)
		{
		    if (fi -> leftbutton[i] != 10 && fi -> leftbutton[i] != 0)
			action += fi -> leftbutton[i];
		    else
		    {
			file.writeBlock("leftbutton=", 11);
			file.writeBlock(action.data(), action.length());
			file.writeBlock("\n", 1);
			action = "";
		    }
		}

	    action = "";

	    if (strlen(fi -> rightbutton)) // there is an action associated to the left button
		for (unsigned int i = 0 ; i <= strlen(fi -> rightbutton) ; i++)
		{
		    if (fi -> rightbutton[i] != 10 && fi -> rightbutton[i] != 0)
			action += fi -> rightbutton[i];
		    else
		    {
			file.writeBlock("rightbutton=", 12);
			file.writeBlock(action.data(), action.length());
			file.writeBlock("\n", 1);
			action = "";
		    }
		}

	    action = "";

	    if (fi -> leftIndex > -1 ) // there is a pixmap associated to the left button
	    {
		action.sprintf("%d", fi -> leftIndex);
		file.writeBlock("leftpixmap=", 11);
		file.writeBlock(action.data(), action.length());
		file.writeBlock("\n", 1);
	    }
	    
	    action = "";

	    if (fi -> rightIndex > -1 ) // there is a pixmap associated to the right button
	    {
		action.sprintf("%d", fi -> rightIndex);
		file.writeBlock("rightpixmap=", 11);
		file.writeBlock(action.data(), action.length());
		file.writeBlock("\n", 1);
	    }

	    action = "";	
	}

	file.close();	

}
