/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __CONFIGTB_H__
#define __CONFIGTB_H__

#include <qstring.h>
#include <qstrlist.h>
#include <qlist.h>
#include <qfile.h>
#include <qpixmap.h>
#include <stdlib.h>

struct actioninfo
{
	char leftbutton[2048]; // Actions to execute (must be separated by \n)
	char rightbutton[2048]; // Actions to execute (must be separated by \n)
	unsigned char leftPixmap[2048]; // picture to display in the toolbar (left button)
	unsigned char rightPixmap[2048]; // dito for the right one
	int leftIndex; // index corresponding to the pixmap of left button
	int rightIndex;
};

// NOTE : for explanations of the functions please refer to the cconfig.h file

class CConfigToolBar
{
	public:
		CConfigToolBar(QString file);
		
		actioninfo *get(const unsigned int index);
		
		void set(const unsigned int i, actioninfo *k);

		int addEntry(QString leftValue, int leftIndex, QString rightValue, int rightIndex);
		
		bool removeEntry(int ind);
		
		void clear() { free(total); total = 0; nb = 0; }

		void save();
		
		~CConfigToolBar() { save(); }
		
	private:

		void readFile();
		
		QString localName;
    
		actioninfo *total;
		
		bool changed;
		
		char buffer[2048];
		
		unsigned int nb;
		
		actioninfo *actionInfo, *parcours;

};

#endif
