/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include <stdio.h> // tmpnam()
#include <stdlib.h> // getenv()
#include "CFileTypesDialog.h"
#include "CFileEventsDialog.h"

CFileTypesDialog::CFileTypesDialog(CConfig *config, CConfigOpt *configo, QWidget *parent, const char *name)
	: fileTypesDialog(parent, name), lc(config), lco(configo)
{
	duplicate -> setEnabled(FALSE);
	remove -> setEnabled(FALSE);
	store -> setEnabled(FALSE);
	edit -> setEnabled(FALSE);

}


void CFileTypesDialog::addEntry(QString entry)
{
	list -> insertItem(entry.data());
}


void CFileTypesDialog::OnEdit()
{
	int n = current;
	CFileEventsDialog cf(lc, lco, current, this);
	cf.exec();
	fileinfo *lf = lc -> getByIndex(current);
	list -> removeItem(current);
	list -> insertItem(lf -> title, n);
	list -> setCurrentItem(n);
}


void CFileTypesDialog::OnAdd()
{
	int res = lc -> addEntry();
	fileinfo *lf = lc -> getByIndex(res);

	//debug("%s", lf -> title);
	list -> insertItem(lf -> title);
	list -> setCurrentItem(res);
	debug("%d", res);
}


void CFileTypesDialog::OnRemove()
{
	lc -> removeEntry(current);
	list -> removeItem(current);
}


void CFileTypesDialog::OnCancel()
{
	done(0);
}


void CFileTypesDialog::OnSave()
{
	lc -> save();
	// save the configuration
	done(0);
}


void CFileTypesDialog::OnUse() 
{
	done(0);
}


void CFileTypesDialog::highlighted(int n)
{
	current = n;	
	edit -> setEnabled(TRUE);
}


void CFileTypesDialog::selected(int n)
{
	current = n;
	CFileEventsDialog cf(lc, lco, n, this);
	cf.exec();
	fileinfo *lf = lc -> getByIndex(current);
	list -> removeItem(current);
	list -> insertItem(lf -> title, n);
	list -> setCurrentItem(n);
}
