/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include <qfile.h>
#include <qmultilinedit.h>
#include "internalCommands.h"

internalCommands::internalCommands(QWidget *parent, const char *name)
    : QWidget(parent, name)
{
    children = 0;
}

void internalCommands::textViewer(QString path)
{
    children = new QMultiLineEdit(this);

    int read;
    QString insert;
    QFile file(path);
    file.open( IO_ReadOnly );
    bool specialCar = FALSE;
	char p[4096 + 1];

    while(!file.atEnd())
    {
		read = file.readLine(p, 4096);
		for(;;)
		{
			if(p[strlen(p) - 1] == '\n' || p[strlen(p) - 1] == '\r')
				p[strlen(p) - 1] = '\0';
			else
				break;
		}


		((QMultiLineEdit *)children) -> insertLine(p);
		
		
    }

    setCaption(path.data());
	//((QMultiLineEdit *)children) -> setCursorPosition(0, 0);
    children -> show();
}

void internalCommands::resizeEvent(QResizeEvent *e)
{
    if (children)
    children -> setGeometry(0, 0, width(), height());
}
