/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include <qapplication.h> // QApplication
#include <stdlib.h> // getenv()
#include <sys/stat.h> // mkdir()
#include <sys/types.h> // mkdir()
#include <fcntl.h> // mkdir()
//#include <qpixmapcache.h>
//#include <unistd.h> // mkdir()
#include <errno.h> // mkdir()
#include "fenetre.h"
#include "manager.h"

#define ENABLE_OPENGL

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	a.setStyle(WindowsStyle);

	QString env;
#if defined(WIN32)
	char path[MAX_PATH + 1];
	GetWindowsDirectory(path, MAX_PATH);
	env = path;
#else	
	env = getenv("HOME");
#endif
	env += "/.zfm";

	int res;

	if (!QFile::exists(env.data()))
	{
	    QDir d;
		res = d.mkdir(env.data());
	    if (res == -1 && errno != EEXIST)
	    {
		debug("Could not create the directory %s, aborting.", env.data());
		debug("This is the corresponding errno number (see /usr/include/errno.h) : %d", errno);
		exit(12);
	    }
	}

	QString env2 = QString(env);
	QString env3 = QString(env);
	env += "/filetypes";
	env2 += "/options";
	env3 += "/toolbar";

	CConfig *configFileType = new CConfig(env);
	CConfigOpt *configOptions = new CConfigOpt(env2, QDir::current());
	CConfigToolBar *configToolBar = new CConfigToolBar(env3);

	ZManager manager(configFileType, configOptions, configToolBar);
	
	return a.exec();

} // main()
