/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MANAGER_H__
#define __MANAGER_H__

#include <qwidget.h>
#include "cconfig.h"
#include "configOpt.h"
#include "configToolBar.h"
#include "utils.h"

class ZManager
{
    public:
	ZManager(CConfig *conf1, CConfigOpt *conf2, CConfigToolBar *conf3);
	~ZManager();

	void addWindow();
	// appelle quand on doit ouvrir une nouvelle fenetre
	// (a partir du menu new window d'une des fenetres filles)

	void windowClosed(void *);
	// appelle quand une fenetre vient d'etre fermee

	void rescanPlugins();

	void quit();
	// appelle a partir du menu quit d'une des fenetres filles
	// met fin a l'application et enregistre la position
	// de toutes les fenetres

	QStrList getInPluginList() { return inPluginList; }
	// renvoie une liste de tous les plugins presents
	// avec --- pour separer en les in_ et les out_ plugins

	QStrList getOutPluginList() { return outPluginList; }

    private:
	CConfigOpt *configOpt;
	CConfig *config;
	CConfigToolBar *configToolBar;
	int nbWindows;

	QStrList inPluginList;
	QStrList outPluginList;
};

#endif
