#ifndef __COLORDIALOG_H__
#define __COLORDIALOG_H__

#include <qdialog.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qstrlist.h>
#include <qlist.h>

struct rgb
{
	int red;
	int green;
	int blue;
};


class ZColorDialog : public QDialog
{
	Q_OBJECT
	public:
		ZColorDialog(QWidget *parent = 0, const char * name = 0, bool modal = FALSE);

		void addEntry(char *entry, QColor color);
		// sert a rajouter des entree dans la liste des choix
		// rajoute egalement la couleur qui lui correspond

	signals:
		void colorChanged(int id, QColor color);
		// chaque fois que l'on change la valeur d'une couleur, emet un signal
		// avec l'identificateur de cette couleur (par rapport a la liste)
		// et la nouvelle valeur de cette couleur (sous forme de QColor)

		void sliderReleased();
		// envoye quand on a relache un slider

	protected slots:
		void sliderMoved();
		// quand un slider a ete bouge

		void listClicked(int);

		
		
	protected:
		void updateSliders();
		// quand l'utilisateur clicke dans la liste de gauche, il faut mettre
		// a jour les sliders pour correspondre a la couleur

		QListBox *listbox;
		// pour afficher le choix des couleurs a changer

		QPushButton *ok;
		// boutton "ok"

		QSlider *red, *green, *blue;
		// les trois slider pour changer la couleur

		QLabel *label;
		// label pour montrer ce que donne cette couleur

		void resizeEvent(QResizeEvent *);

		int currentColor;

		rgb color[9];
};

#endif
