//
// z3dfm by yean 
//

#include <qgl.h>
#include <qapp.h>
#include <math.h>
#include <stdlib.h>
#include <qlist.h>
#include <qlabel.h>
#include <qdir.h>
#include <qscrbar.h>
#if !defined(WIN32)
#include <unistd.h>
#endif
#include <qfile.h>
#include <qfileinf.h>
#include "file.h"
#include "zglcomponent.h"

#if defined(WIN32)
#define M_PI 3.14
#endif

// flags :
// Les deux lignes suivantes devraient permettre d'avoir plusieurs
// sourcesde lumiere. Mais MESA en supporte actuellement une seule...
/*
  bool cursor_light = FALSE; // determine si le curseur est source de lumiere
  bool ambient_light = TRUE; // active la lumiere ambiente
*/

bool cursor_light = TRUE;
bool animate_selected = TRUE;
bool cursor3D_enabled = FALSE;

// Taille des box :
GLfloat box_width  = 4.0;
GLfloat box_height = 3.0;

// Espace entre les box :
GLfloat box_space_x = 10.0;
GLfloat box_space_y = 10.0;

// Taille des box en pixels (une approximation) :
int box_width_pixel  = 120;
int box_height_pixel = 86;



// Taille de la fenetre de reference :
int width_reference_window = 320;
int height_reference_window = 240;

// Set to true if you want the program to quit after running one binary
// NOTE: This is set by the command line option -r
bool runone = false;

// TEXT STUFF
GLint charlist[256]; // list of the display lists, one for each char

// Super Duper Text Generation thingie
// First char is the letter, then a series of codes:
//  P[1,2][1,2][1,2] ... -- a series of points
//  L[1,2][1,2][1,2] ... -- a series of lines
//  S[1,2][1,2][1,2] ... -- a strip of lines
//  O[1,2][1,2][1,2] ... -- a loop of lines (ends are connected)
// remember that the last point of a line is not drawn!
// last entry is signalled by ""
// text space is: (automatically scaled by parser)
//   +-----+  1
//   |     |
//   |     |
//   |     |
//   +-----+  -1
//  -1     1

char* textData[256] = {
   ".P[0,-1]",
   "AS[-1,-1][-1,.5][-.5,1][.5,1][1,.5][1,-1]P[1,-1]L[-1,0][1,0]",
   "BS[.5,0][1,-.5][.5,-1][-1,-1][-1,1][.5,1][1,.5][.5,0][-1,0]",
   "CS[1,-.5][.5,-1][-.5,-1][-1,-.5][-1,.5][-.5,1][.5,1][1,.5]P[1,.5]",
   "DO[-1,-1][-1,1][.5,1][1,.5][1,-.5][.5,-1]",
   "ES[1,-1][-1,-1][-1,1][1,1]P[1,1]L[-1,0][.5,0]",
   "FS[-1,-1][-1,1][1,1]P[1,1]L[-1,0][.5,0]",
   "GS[0,0][1,0][1,-.5][.5,-1][-.5,-1][-1,-.5][-1,.5][-.5,1][.5,1][1,.5]P[1,.5]",
   "HL[-1,-1][-1,1][1,-1][1,1][-1,0][1,0]P[-1,1][1,1]",
   "IL[-1,-1][1,-1][-1,1][1,1][0,1][0,-1]P[1,1][1,-1]",
   "JS[-1,-.5][-.5,-1][0,-.5][0,1]L[-1,1][1,1]P[1,1]",
   "KL[-1,-1][-1,1][1,1][-1,0][1,-1][-1,0]P[-1,1]",
   "LS[-1,1][-1,-1][1,-1]P[1,-1]",
   "MS[-1,-1][-1,1][0,.5][1,1][1,-1]P[1,-1]",
   "NS[-1,-1][-1,1][1,-1][1,1]P[1,1]",
   "OO[-.5,-1][-1,-.5][-1,.5][-.5,1][.5,1][1,.5][1,-.5][.5,-1]",
   "PS[-1,-1][-1,1][.5,1][1,.5][.5,0][-1,0]",
   "QO[-.5,-1][-1,-.5][-1,.5][-.5,1][.5,1][1,.5][1,-.5][.5,-1]S[1,-1][.5,-.5][-.5,-.5]",
   "RS[-1,-1][-1,1][.5,1][1,.5][.5,0][-1,0]L[1,-1][.5,0]",
   "SS[-1,-.5][-.5,-1][.5,-1][1,-.5][.5,0][-.5,0][-1,.5][-.5,1][1,1]",
   "TL[0,-1][0,1][-1,1][1,1]P[1,1]",
   "US[-1,1][-1,-.5][-.5,-1][.5,-1][1,-.5][1,1]P[1,1]",
   "VS[-1,1][0,-1][1,1]P[1,1]",
   "WS[-1,1][-.5,-1][0,0][.5,-1][1,1]P[1,1]",
   "XL[-1,1][1,-1][1,1][-1,-1]P[-1,-1][1,-1]",
   "YL[-1,1][0,0][1,1][-1,-1]P[-1,-1]",
   "ZS[1,-1][-1,-1][1,1][-1,1]P[-1,1]",
   "aO[1,0][-.5,0][-1,-.5][-.5,-1][.5,-1][1,-.5]L[1,-1][1,-.5]",
   "bS[-1,1][-1,-1][.5,-1][1,-.5][.5,0][-1,0]",
   "cS[1,-1][-.5,-1][-1,-.5][-.5,0][1,0]P[1,0]",
   "dS[1,1][1,-1][-.5,-1][-1,-.5][-.5,0][1,0]",
   "eS[-1,-.5][1,-.5][.5,0][-.5,0][-1,-.5][-.5,-1][1,-1]P[1,-1]",
   "fS[1,1][0,1][0,-1]L[-.5,0][.5,0]P[0,-1][.5,0]",
   "gS[1,-1][-.5,-1][-1,-.5][-.5,0][1,0][1,-1][.5,-1.5][-1,-1.5]P[-1,-1.5]",
   "hL[-1,-1][-1,1]S[1,-1][1,0][-1,0]",
   "iL[0,-1][0,0]P[0,0][0,.5]",
   "jS[-1,-1.5][-.5,-1.5][0,-1][0,0]P[0,0][0,.5]",
   "kL[-.5,-1][-.5,1][1,0][-.5,-.5][1,-1][-.5,-.5]P[-.5,1]",
   "lS[-.5,1][-.5,-1][.5,-1]P[.5,-1]",
   "mS[-1,-1][-1,0][0,0][0,-.5]S[1,-1][1,0][0,0]",
   "nS[-1,-1][-1,0][.5,0][1,-.5][1,-1]P[1,-1]",
   "oO[-.5,-1][.5,-1][1,-.5][.5,0][-.5,0][-1,-.5]",
   "pS[-1,-1.5][-1,0][.5,0][1,-.5][.5,-1][-1,-1]",
   "qS[.5,-1][-.5,-1][-1,-.5][-.5,0][.5,0][.5,-1.5][1,-1]",
   "rL[-1,-1][-1,0]S[1,0][-.5,0][-1,-.5]P[-1,0]",
   "sS[-1,-1][1,-1][1,-.5][-1,-.5][-1,0][1,0]",
   "tL[0,1][0,-1][1,0][-1,0]P[0,-1]",
   "uS[-1,0][-1,-.5][-.5,-1][.5,-1][1,-.5][1,0]L[1,-1][1,-.5]",
   "vS[-1,0][0,-1][1,0]P[1,0]",
   "wS[-1,0][-.5,-1][0,0][.5,-1][1,0]P[1,0]",
   "xL[-1,0][1,-1][-1,-1][1,0]P[1,0][1,-1]",
   "yS[-1,-1.5][-.5,-1.5][1,0]L[-1,0][0,-1]P[1,0]",
   "zS[-1,0][1,0][-1,-1][1,-1]P[1,-1]",
   "0O[-.5,-1][-1,-.5][-1,.5][-.5,1][.5,1][1,.5][1,-.5][.5,-1]L[-1,-1][1,1]P[1,1]",
   "1S[-1,0][0,1][0,-1]L[-1,-1][1,-1]P[1,-1]",
   "2S[-1,.5][-.5,1][.5,1][1,.5][1,0][-1,-1][1,-1]P[1,-1]",
   "3S[-1,.1][-.5,1][.5,1][1,.5][.5,0][1,-.5][.5,-1][-.5,-1][-1,-.5]L[0,0][.5,0]P[-1,-.5]",
   "4S[1,-.5][-1,-.5][.5,1][.5,-1]P[.5,-1]",
   "5S[1,1][-1,1][-1,-.25][-.5,0][.5,0][1,-.5][.5,-1][-1,-1]P[-1,-1]",
   "6S[1,1][0,1][-1,0][-1,-1][1,-1][1,0][-1,0]",
   "7S[-1,1][1,1][-1,-1]P[-1,-1]",
   "8S[-.5,0][-1,.5][-.5,1][.5,1][1,.5][.5,0][1,-.5][.5,-1][-.5,-1][-1,-.5][-.5,0][.5,0]",
   "9S[1,0][-1,0][-1,1][1,1][1,-1]P[1,-1]",
   "-S[-1,0][1,0]P[1,0]",
   "_S[-1,-1][1,-1]P[1,-1]",
   "~S[-1,.5][-.5,1][.5,.5][1,1]P[1,1]",
   ""
};



// Load all that data into display lists for later (quick) use
void initChars()
{
   // Define the blank char
   charlist[0] = glGenLists( 1 );
   glNewList( charlist[0], GL_COMPILE );
   // A single stroke
   glBegin( GL_LINES );
   glVertex3f(-1,-1,0); glVertex3f(1,1,0);
   glEnd();
   glEndList();
   // Set the rest to blank chars by default
   for(int jl = 1; jl < 256; jl++) charlist[jl] = charlist[0];
   // Generate the chars from the data:
   for( char **i = textData, *j = *i; *j; j = *(++i) ) {
      // Make a copy we can use
      char* s = j;
      bool needEnd = false;
      // Start the new list
      charlist[ *s ] = glGenLists( 1 ); glNewList( charlist[ *s ], GL_COMPILE ); glNormal3f( 0, 0, 1 );
      // On your marks... GO!!!
      while( *++s )
	switch ( *s ) {
	 case 0: printf("OOPS!! Got a ZERO in data processing!!! ARGH!!!\n"); break;
	 case 'P': if( needEnd ) glEnd(); glBegin( GL_POINTS ); needEnd = true; break;
	 case 'L': if( needEnd ) glEnd(); glBegin( GL_LINES ); needEnd = true; break;
	 case 'S': if( needEnd ) glEnd(); glBegin( GL_LINE_STRIP ); needEnd = true; break;
	 case 'O': if( needEnd ) glEnd(); glBegin( GL_LINE_LOOP ); needEnd = true; break;
	 case '[': {
	    if( !needEnd ) { printf("OOPS!! Got a [ but not in a data thingie!! fewl :P\n"); break; }
	    // I prefer to reinvent the wheel.. it`s experience dontcha know :P
	    GLfloat x = 0, y = 0, decimal = 1; bool sign = false;
	    // Lesson 324:638.001 - Char pointers
	    if( *++s == '-' ) sign = true, s++;
	    // while there`s a number (before the decimal point)
	    while( *s >= '0' && *s <= '9' )
	      x = x * 10 + *s++ - '0';
	    // if there is a decimal point..
	    if( *s == '.' )
	      // while there`s a number
	      while( *++s >= '0' && *s <= '9' )
		x += ( *s - '0' ) / ( decimal *= 10 );
	    // account for the sign
	    if( sign ) x = -x;
	    // reset
	    decimal = 1; sign = false;
	    // and do it again
	    if( *++s == '-' ) sign = true, s++;
	    while( *s >= '0' && *s <= '9' )
	      y = y * 10 + *s++ - '0';
	    if( *s == '.' )
	      while( *++s >= '0' && *s <= '9' )
		y += ( *s - '0' ) / ( decimal *= 10 );
	    if( sign ) y = -y;
	    // create this vertex, and scale the x so that the letter fit nicely together when drawn.
	    glVertex3f( x * 0.7, y, 0 );
	    break;
	 }
	 default:
	   printf("OOPS!! Unknown char in data processing: '%c'\n", *s);
	}
      // End the whatever if we need to..
      if( needEnd ) glEnd();
      // End the list
      glEndList();
   }
}

// Display a string
void dispString(const char* s)
{
   // Give us our own space
   glPushMatrix();
   // for each char
   while( s && *s ) {
      // Draw this char
      if( *s != ' ' ) glCallList( charlist[(int)*(s)] );
      // and move along
      s++;
      glTranslatef( 2,0,0 );
   }
   // Go back into the previous space
   glPopMatrix();
}

// Display a centered string
void dispStringC(const char* s)
{
   // Just set an offset first, the rest is the same as above
   glPushMatrix();
   glTranslatef( -(GLfloat)strlen(s),0,0 );
   while( s && *s ) {
      if( *s != ' ' ) glCallList( charlist[(int)*(s)] );
      s++;
      glTranslatef( 2,0,0 );
   }
   glPopMatrix();
}

// A few colours
static GLfloat colour[][4] = {
     {0.9, 0.9, 0.0, 1.0 },
     {0.0, 0.8, 0.2, 1.0 },
     {0.9, 0.1, 0.0, 1.0 },
     {0.0, 0.4, 0.9, 1.0 },
     {1.0, 1.0, 1.0, 1.0 }
};
// force Colour:: prefix ... need to override Qt`s const QColor`s :/
struct Colour { 
   enum colour {
      yellow=0,green,red,blue,white
   }; 
};



// Smoothing functions
// Give them an x from 0 to 1
// it will interpolate from (0,0) to (1,1) smoothly.
// the number is the gradient (rise/run) at 1,1
inline float smooth0( float x )
{
   // looks like:
   //      /~~~
   //     /
   // ___/   (except smoother!;)
   return 3*x*x-2*x*x*x;
}
// The next three look like:
//      /
//     /
// ___/  (except smoother!;)
inline float smooth1( float x )
{
   return x;
}
inline float smooth2( float x )
{
   return x*x;
}
inline float smooth3( float x )
{
   return x*x*x;
}
inline int semirand( float x )
{
   return (int)(fabs(x*M_PI*34535.45327403)) % 3;
}

// Make a sphere
static void makesphere( GLfloat size )
{
   for( int h = 1; h <= 10; h++ ) {
      glBegin( GL_QUAD_STRIP );
      GLfloat y = cos( (float)h * M_PI / 10 ) * size;
      GLfloat oldy = cos( (float)(h - 1) * M_PI / 10 ) * size;
      GLfloat s = sin( (float)h * M_PI / 10 ) * size;
      GLfloat olds = sin( (float)(h - 1) * M_PI / 10 ) * size;
      for( int w = 0; w <= 20; w++ ) {
	 GLfloat x = sin( (float)w * M_PI / 10 );
	 GLfloat z = -cos( (float)w * M_PI / 10 );
	 glNormal3f( x * s, y, z * s );
	 glVertex3f( x * s, y, z * s );
	 glNormal3f( x * olds, oldy, z * olds );
	 glVertex3f( x * olds, oldy, z * olds );
      }
      glEnd();
   }	 
}





// Make a box shape
// NOTE DE YEAN :
// La ligne suivante, qui apparait 4 fois, semble etre superflue :
//       glNormal3f( 0, -curve[4-i], curve[i] );
// en effet, le vecteur curve[] ne va que jusqu'a 2,
// alors que i a pour premiere valeur 0
// Le programme essaie donc de referencer l'element 4 du tableau curve[]
// or cet element n'existe pas.
// J'ai supprime la ligne du programme, et cela ne change effectivement rien.

//*********************************
//*				  *
//*   Un autre objet 3D		  *
//*				  *
//*********************************


static void makebox( GLfloat width, GLfloat height, GLfloat thickness )
{

   GLfloat profondeur = width;

   // Modele de rendu :
   glShadeModel( GL_FLAT );
   glShadeModel( GL_SMOOTH );


   // Gauche :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (-width, 0, + profondeur);
      glVertex3f (-width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, -width / 4 + profondeur);
   glEnd();

   // Droite :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (width, 0, 0 + profondeur);
      glVertex3f (width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, -width / 4 + profondeur);
   glEnd();

   // Haut :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (0, width, 0 + profondeur);
      glVertex3f (-width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, -width / 4 + profondeur);
   glEnd();

   // Bas :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (0, -width, 0 + profondeur);
      glVertex3f (-width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, -width / 4 + profondeur);
   glEnd();

   // Devant :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (0, 0, -width + profondeur);
      glVertex3f (-width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, -width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, -width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, -width / 4 + profondeur);
   glEnd();

   // Derriere :
   glBegin( GL_TRIANGLE_FAN );
      glVertex3f (0, 0, width + profondeur);
      glVertex3f (-width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (width / 4, width / 4, width / 4 + profondeur);
      glVertex3f (width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, -width / 4, width / 4 + profondeur);
      glVertex3f (-width / 4, width / 4, width / 4 + profondeur);
   glEnd();

}


void FileWidget::DrawLight()
{
   // Position of the light
   Vector light;

   // Set the light
   if ( cursor_light ) // si le curseur est source de lumiere
   {
      light = Vector( selx, sely, 10.0, 1.0 );
   }
   else
   {
      light = Vector( -20.0, 10.0, 10.0, 1.0 );
   }
   glLightfv( GL_LIGHT0, GL_POSITION, light );
}

outModule::outModule()
    : outGLComponent() {}


QGLWidget *outModule::getNewWidget(CConfig *f, QWidget *parent, const char *name)
{
    component = new FileWidget(f, parent, name);
    //debug("component = %d", component);
    return component;
}


void outModule::display(ZList &list)
{
    component -> display(list);
}


void outModule::displayDevices(ZListDevice &list)
{
	component -> displayDevices(list);
}

QStrList outModule::getMenu()
{
    return component -> getMenu();
}


void outModule::menuClicked(int id)
{
	component -> menuClicked(id);
}


extern "C" outGLComponent 
#ifdef WIN32
__declspec(dllexport)
#endif
*getNewOutGLModule()
{
    return new outModule;
}

FileWidget::FileWidget( CConfig *f, QWidget *parent, const char *name )
  : outGLComponent( parent, name ), dragging( false ), 
    first_time( TRUE ), state( 100 ), pos( 0, 0, -70 ),
    selbox( (uint)-1 ), firstbox( 10000 )
{
  time = 100;

  setFocusPolicy(QWidget::StrongFocus);

  timer = new QTimer(this, "timer");

  connect(timer, SIGNAL(timeout()), SLOT(update()));

  // Set the timer to update the display every 10ms if possible.
  //if ( animate_selected )
  setTimer(TRUE);

   setMouseTracking( true );
}


QStrList FileWidget::getMenu()
{
    QStrList tmp;

	if (cursor3D_enabled == TRUE)
		tmp.append("Display 3D caret_1");
	else
		tmp.append("Display 3D caret_0");
	
	if (cursor_light)
		tmp.append("Light source_1");
	else
		tmp.append("Light source_0");
			
	if (animate_selected)
		tmp.append("Animations_1");
	else
		tmp.append("Animations_0");

    return tmp;
}


void FileWidget::menuClicked(int id)
{
	if (id == 0) // curseur 3D
	{
		debug("ok");
		if (cursor3D_enabled == TRUE)
			cursor3D_enabled = FALSE;
		else
			cursor3D_enabled = TRUE;

		debug("%d", cursor3D_enabled);
	}


	if (id == 1) // source de lumiere
	{
		if (cursor_light)
			cursor_light = FALSE;
		else
			cursor_light = TRUE;
	}


	if (id == 2) // animation
	{
		if (animate_selected)
			animate_selected = FALSE;
		else
			animate_selected = TRUE;
	}

repaint();
}

void FileWidget::setTimer(bool n)
{
  if (n == TRUE) // il faut activer le timer
    timer -> start(time);
  else
    timer -> stop();
}


void FileWidget::focusInEvent(QFocusEvent *e)
{
  setTimer(TRUE);
}

void FileWidget::focusOutEvent(QFocusEvent *e)
{
  setTimer(FALSE);
}


void FileWidget::resizeGL( int width, int height )
{

   // Calcul de la matrice de perspective :
   GLfloat h = (float) height / (float) height_reference_window;
   GLfloat w = (float) width  / (float) width_reference_window;

   // Active la lumiere :
   DrawLight();

   // Set the light and other details
   glEnable( GL_CULL_FACE );
   glEnable( GL_LIGHTING );
   glEnable( GL_LIGHT0 );
   glEnable( GL_DEPTH_TEST );
   
   if ( first_time ) {
      first_time = FALSE;
      initChars();

      // make the box template (display list)
      file1 = glGenLists(1);
      glNewList(file1, GL_COMPILE);
      makebox( box_width, box_height, 1 );
      glEndList();
   
      // make the selection pointer template
      sel1 = glGenLists(1);
      glNewList(sel1, GL_COMPILE);
      makesphere( 2 );
      glEndList();

   }
   
   glEnable( GL_NORMALIZE );
   
   // Set some display properties
   glViewport( 0, 20, width-20, height-20 );
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();

   //w = 1.783972;
   //h = 1.0;
   glFrustum( -w, w, -h, h, 5.0, 600.0 );
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   
   updateSelection();
}

void FileWidget::paintGL()
{

   // Increase the animation frame count
   angle += 2.0;
   
   // Clear the buffer
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   // Start a new matrix-space
   glPushMatrix();
      
   // Rotate to the display
   glRotatef( rot.x(), 1.0, 0.0, 0.0 );
   glRotatef( rot.y(), 0.0, 1.0, 0.0 );
   glRotatef( rot.z(), 0.0, 0.0, 1.0 );

   // Move us along due to momentum
   pos += vel;
   // Slow us down due to friction
   vel *= 0.9;

   // Move us to where we are
   glTranslatef( pos.x(), pos.y(), pos.z() );

   // Active la lumiere :
   DrawLight();


   // Axis lines, used as a pointer atm
   glPushMatrix();
   // Bouncy effect
   GLfloat z = 20 - smooth2((((int)angle)%20)/10.0-1) * 18;
   GLfloat w = 0.5 + smooth2((((int)angle-2)%20)/10.0-1);
   glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[Colour::yellow] );




   // Dessin du curseur de la souris en 3D :

   if ( cursor3D_enabled )
   {

      // Make a splat/circle
      glBegin( GL_POLYGON );
      glNormal3f( 0, 0, 1 );
      for( int b = 0; b <= 16; b++ ) {
         glVertex3f( selx + cos( b*M_PI/8 ) * (3+w), sely + sin( b*M_PI/8) * (3+w), -.1 );
      }
    
      glEnd();


      // Make a beam
      glBegin( GL_QUAD_STRIP );
      for( int a = 0; a <= 16; a++ ) {
         glNormal3f( cos( a*M_PI/8 ), -sin( a*M_PI/8), 0 ); 
         glVertex3f( selx + cos( a*M_PI/8 ) * w, sely - sin( a*M_PI/8) * w, 0 );
         glVertex3f( selx + cos( a*M_PI/8 ) * w, sely - sin( a*M_PI/8) * w, z );
      }
      glEnd();
      // With a sphere on top
      glTranslatef(selx, sely, z);
      glCallList( sel1 );
      // Uncomment if you prefer to have x/y/z axis instead of the stupid sphere
   /*   glBegin( GL_LINES );
      glNormal3f( 0, 0, 1 );
      glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[Colour::red] );
      glVertex3f( 0, 0, 0 );
      glVertex3f( 10, 0, 0 );
      glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[Colour::green] );
      glVertex3f( 0, 0, 0 );
      glVertex3f( 0, 10, 0 );
      glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[Colour::blue] );
      glVertex3f( 0, 0, 0 );
      glVertex3f( 0, 0, 10 );
      glEnd();*/

   }

   glPopMatrix();

   // Keep track of the animatedly selected move
   if( state >= 100 ) movesel = selbox;
   
   // Draw all the boxes...
   for( uint i = 0; i < boxInfo.count(); i++) {
      // Start a new matrix-space for this box, so as not to interfere with the other boxes/things
      glPushMatrix();

      // Choose the colour
      glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[ (i==movesel && ((int)angle % 10 < 5) ) ? Colour::yellow : boxInfo.at(i)->colour ] );
      // Move to where the box is
      glTranslatef( boxInfo.at(i)->x, boxInfo.at(i)->y, boxInfo.at(i)->z );

      // If these are the boxes of the new directory zooming forward
      if( i >= firstbox ) {
	 // But those aren`t visible yet
	 if( state >= 100 ) {
	    // Get out of this space and move to the next box
	    glPopMatrix();
	    continue;
	 }
	 // other wise move to where that set of boxes are
	 glTranslatef( 0, 0, - 1000 * ( smooth3( state/100 ) ) );
	 if( i == movesel ) {
	    // Randomish rotation:
	    GLfloat fraction = angle; //smooth3( (100-angle)/100 );
	    glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 1 ) ) * ( 1 - semirand( i + 4 ) ) ) ), 1.0, 0.0, 0.0 );
	    glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 2 ) ) * ( 1 - semirand( i + 5 ) ) ) ), 0.0, 1.0, 0.0 );
	    glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 3 ) ) /* -always do this one!- */ ) ), 0.0, 0.0, 1.0 );
	 }
      } else if( i == movesel ) {
	 if( state >= 100 ) {
	    // Might do something else in the future...
	    // atm just a yellow colour is chosen above
	 } else if( state > 70 ) {
	    // Fall over...
	    glTranslatef( 0, (cos(smooth3((100-state)/30)*M_PI/2)-1) * 3, sin(smooth3((100-state)/30)*M_PI/2) * 3 );
	    glRotatef( smooth3((100-state)/30)*90, 1.0, 0.0, 0.0 );
	 } else {
	    // Zoom forward...
	    glTranslatef( 0, -3, 3 + smooth3(1-state/70)*150 );
	    glRotatef( 90, 1.0, 0.0, 0.0 );
	 }
	 // Randomish rotation:
	 GLfloat fraction = angle;
	 glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 1 ) ) * ( 1 - semirand( i + 4 ) ) ) ), 1.0, 0.0, 0.0 );
	 glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 2 ) ) * ( 1 - semirand( i + 5 ) ) ) ), 0.0, 1.0, 0.0 );
	 glRotatef( 5 * sin( fraction * ( 10 * ( 3 + semirand( i + 3 ) ) /* -always do this one!- */ ) ), 0.0, 0.0, 1.0 );
      } else {
	 // If we`re in motion...
	 if( state < 100 ) {
	    // Zoom forward...
	    glTranslatef( 0, 0, smooth2(1-state/100)*150 );
	    // Randomish rotation:
	    GLfloat fraction = smooth3( (100-state)/100 );
	    glRotatef( 5 * sin( fraction * ( 30 * ( 3 + semirand( i + 1 ) ) * ( 1 - semirand( i + 4 ) ) ) ), 1.0, 0.0, 0.0 );
	    glRotatef( 5 * sin( fraction * ( 30 * ( 3 + semirand( i + 2 ) ) * ( 1 - semirand( i + 5 ) ) ) ), 0.0, 1.0, 0.0 );
	    glRotatef( 5 * sin( fraction * ( 30 * ( 3 + semirand( i + 3 ) ) * ( 1 - semirand( i + 6 ) ) ) ), 0.0, 0.0, 1.0 );
	 }
      }
      // Draw the box
      glCallList( file1 );
      // Move to the text area
      glTranslatef( 0, -4, 0 );
      // Make the text a bit smaller
      glScalef(0.4,0.4,1);
      glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colour[Colour::white] );
      // Draw the text
      dispStringC( boxInfo.at(i)->name );
      //dispStringC( "Lalalere" );
      glPopMatrix();
   }
   
   // Update the State!
   if(state<100) state-=3;
   // If the animation has finished...
   if(state < 0) {
      // Delete all the boxes from the old directory, which is now behind us
      for( uint i = 0; i < firstbox; i++ )
	boxInfo.removeFirst();
      state = 100;
      updateSelection();
      firstbox = boxInfo.count();
   }
   glPopMatrix();
}

void FileWidget::setMovement( bool move )
{
   // 100 == don`t move, <100 == move
   state = 100 - move;
}

void FileWidget::update()
{
  // Redraw the screen every 10ms when this is called
  updateGL();
}

void FileWidget::mousePressEvent( QMouseEvent *mouse )
{
   if( mouse->button() == RightButton ) {
      // Right mouse is drag, so we grab the mouse and remember where we are
      grabMouse();
      dragpos = mapToGlobal( mouse->pos() );
      dragging = true;
   } else if ( mouse->button() == LeftButton ) {
      // uncomment to allow movement with left button
      //       vel += Vector(-sin( rot.y() * M_PI/180 )*cos( rot.x() * M_PI/180 ),
      //		     sin( rot.x() * M_PI/180 ),
      //		     cos( rot.y() * M_PI/180 )*cos( rot.x() * M_PI/180) );
      // otherwise select this item
      firstbox = boxInfo.count();

	  if (selbox > local.count() - 1) return;		
      QFileInfo curfile(local.at(selbox));
      if (curfile.isDir() && curfile.isExecutable())
	  {
		setMovement( true );
      
        movesel = selbox;
      }
        emit dblClicked(local.at(selbox), mouse -> state());
   }
}

void FileWidget::mouseReleaseEvent( QMouseEvent *mouse )
{
   if( dragging ) {
      // Stop dragging the mouse, and let it go
      mouseMoveEvent( mouse );
      releaseMouse();
      dragging = false;
   }
}

void FileWidget::mouseMoveEvent( QMouseEvent *me )
{
   if( dragging ) {
      // Find out how far the mouse has moved since we last looked
      QPoint newpos = mapToGlobal( me->pos() );
      QPoint move = newpos - dragpos;
      dragpos = newpos;
      
      // And rotate according to how far the mouse has moved
      rot.setY( rot.y() - (GLfloat)move.x()/10 );
      rot.setX( rot.x() - (GLfloat)move.y()/10 );
   }
   // Update the selection
   mouse = me->pos();
   updateSelection();
}

// A function to convert screen(window actually) coordinates into
// coordinates on the plane where the icons are
Vector FileWidget::screenToPlane(const Vector& mouse)
{

   // Calculate the width of the frustrum by using the aspect ratio
   GLfloat h = (float) height() / height_reference_window;
   GLfloat w = (float) width()  / width_reference_window;


   // Calcul des sinus et cosinus de l'angle de rotation :
   GLfloat cx = cos( rot.x()*M_PI/180 ), sx = sin( -rot.x()*M_PI/180 );
   GLfloat cy = cos( rot.y()*M_PI/180 ), sy = sin( rot.y()*M_PI/180 );

   // Get the mouse coords on the view plane
   GLfloat mx = (float)mouse.x() / width() * 2 * w - w, my = (1.0 - ( (float)mouse.y() / height() ) ) * 2 * h - h, mz = 5;

//   GLfloat mx = (float)mouse.x() / width() * 2 * w - w, my = 1 - (float)mouse.y() * 2 / height(), mz = 5;

   //GLfloat mx = (float)mouse.x() / width() * 2 * w - w, mz = 10 - (float)mouse.y() * 10 / height(), my = 0;

   // Rotate around the x axis
   GLfloat xx = mx, xy = cx * my + sx * mz, xz = cx * mz - sx * my;

   // Rotate around the y axis
   GLfloat yx = cy * xx + sy * xz, yy = xy, yz = cy * xz - sy * xx;

   // Check for underflow
   if( yz < 0.00001 ) yz = 0.00001;

   // Scale to the icons` plane
   return Vector(yx * -pos.z() / yz, yy * -pos.z() / yz, 0);
}

void FileWidget::updateSelection()
{
   // Find out what part of the plane we`re looking at...
   {
      Vector plane( screenToPlane( Vector( mouse.x(), mouse.y() ) ) );
      selx = plane.x();
      sely = plane.y();
   }
   // Now pick the closest icon

   GLfloat best = 1000000000; 
   int num = -1;
   // Iterate through all the icons, keeping track of which is closest
   for( unsigned int i = ( state < 100 ) ? firstbox : 0; i < boxInfo.count(); i++ ) {
      GLfloat dist = (  (selx-boxInfo.at(i)->x)*(selx-boxInfo.at(i)->x)
		      + (sely-boxInfo.at(i)->y)*(sely-boxInfo.at(i)->y) );
      if( dist < best ) {
	 best = dist;
	 num = (int)i;
      }
   }
   // Highlight this box if it`s different to the one we had before
   if( num >= 0 && (int)selbox != num ) {
      selbox = num;
      if (selbox < local.count())
	emit highlighted( local.at(selbox) );
      else
	emit(highlighted(QString("")));
   }
}





void FileWidget::display(ZList &info) // Actualise la liste des fichiers
{
	local.clear();

    //int i;

    int nb_box_x = 3; 
    int nb_box_y = 4; 

    GLfloat x_start = - (float) nb_box_x / 2 * box_space_x;
    GLfloat y_start = - (float) nb_box_y / 2 * box_space_y;

    QFileInfo file;

    GLfloat x = x_start, nb_x = 0;

    for (GLfloat y = y_start, i = 0 ; i < info.count() ; y += 10)
    {
      for (GLfloat x = x_start, nb_x = 0; nb_x<nb_box_x; x += 10, nb_x++, i++)
      {
	if (i < info.count())
	{
	  local.append(info.at(i) -> absFilePath());
	  file = *((QFileInfo *)info.at(i));
	}
	else
	  file.setFile("");

        if ( file.isDir() )
	    boxInfo.append( new BoxInfo(x,y,0,Colour::red, file.fileName() ) );
	else if( file.isExecutable() )
	    boxInfo.append( new BoxInfo(x,y,0,Colour::blue, file.fileName() ));
	else
	    boxInfo.append( new BoxInfo(x,y,0,Colour::green, file.fileName()) );

      }
   }

}


void FileWidget::displayDevices(ZListDevice &info) // Actualise la liste des fichiers
{
    local.clear();

    //int i;

    int nb_box_x = 3; 
    int nb_box_y = 4; 

    GLfloat x_start = - (float) nb_box_x / 2 * box_space_x;
    GLfloat y_start = - (float) nb_box_y / 2 * box_space_y;

    GLfloat x = x_start, nb_x = 0;

    for (GLfloat y = y_start, i = 0 ; i < info.count() ; y += 10)
    {
      for (GLfloat x = x_start, nb_x = 0; nb_x<nb_box_x; x += 10, nb_x++, i++)
      {
		if (i < info.count())
		{
	  		local.append(info.at(i) -> rootPath());
	    	boxInfo.append( new BoxInfo(x,y,0,Colour::red, info.at(i) -> rootPath().data() ) );
		}
      }
   }
}
