#ifndef __INPLUGIN_H__
#define __INPLUGIN_H__

#include <qdir.h>
#include <qstrlist.h>
#include <qstring.h>
#include "../list.h"
#include "inModule.h"

class inPlugin : public inComponent
{
	Q_OBJECT	
	public:

    inPlugin();

	bool open(QString name, int mode);
	bool atEnd();
	int getch();
	void close();
	bool at(int offset);
	int readBlock(char *p, uint len);

    ZList &scan(QString path);
    // scanne le repertoire path et renvoie une liste chainee sur les fichiers et repertoires

	ZListDevice &getDevices();
	// renvoie une liste de tous les peripheriques dispos sur la machine

	QString cdUp();
	// sert a remonter d'un niveau

	bool exists(QString path);
	bool isGoodDir(QString path);
	bool isGoodFile(QString file);	

	QStrList getMenu();
	void menuClicked(int);

  protected:
    
    QDir dir;
    ZList list;
	ZListDevice devices;

	bool dotFiles;
	// pour savoir si on doit afficher les fichiers caches

	bool firstDirs;
	// affichage des repertoires en premier

	bool caseSensitive;
	// sensible aux minuscules/majuscules

	bool optionsChanged;
	// pour savoir si une option a ete changee
	// si non : scan
	// si oui : pas de scan mais un autre tri de la liste

	QFile internal;
};

#endif
