#ifndef __ZCOMPONENT__
#define __ZCOMPONENT__

#include <qwidget.h>
#include "../list.h"
#include "../cconfig.h"

class outComponent : public QWidget
{
	Q_OBJECT
    public:
		outComponent(QWidget *parent = 0, const char *name = 0)
#if defined(__CYGWIN32__)
			: QWidget(parent, name) {}
#else
		:QWidget(parent, name) {}
		virtual QWidget *getNewWidget(CConfig *config, QWidget *parent = 0, const char *name = 0) { return 0; }
#endif
		virtual void display(ZList &) {}
		virtual void displayDevices(ZListDevice &) {}
		virtual QStrList getMenu() { QStrList empty; return empty; }

	public slots:
		virtual void menuClicked(int id) {}
		// recu lorsque l'utilisateur a selectionne un item du menu "options d'affichage"

};	


class inComponent : public QObject
{
	Q_OBJECT
    public:
		inComponent() {}

		virtual bool open(QString name, int mode) = 0;
		virtual bool atEnd() = 0;
		virtual int getch() = 0;
		virtual void close() = 0;
		virtual bool at(int offset) = 0;
		virtual int readBlock(char *p, uint len) = 0;
		
		virtual ZList &scan(QString path) = 0;
		virtual ZListDevice &getDevices() = 0;
		virtual QString cdUp() = 0;
		virtual QStrList getMenu() = 0;
		virtual bool exists(QString path) = 0;
		virtual bool isGoodDir(QString path) = 0;
		virtual bool isGoodFile(QString file) = 0;

	public slots:
		virtual void menuClicked(int) = 0;
};

#endif
